main:  
  gosub Initialize 
  gosub MoveRobot
end

MoveRobot:
   rSpeed 10
   amount = 15
   while 1
     bump = false
     repeat
      GetButton LB
      if LB="Start Over" then goto main
      if LB="Show Objects" then gosub SHOW
      getkey k
      waitnokey
     until k
     k=char(k)
     k=Upper(k)
     if k="L"
       rTurn -amount
       call ReadSensors(sense)
       call OutputCircles(300,350,14,sense)
     elseif k="R"
       rTurn amount
       call ReadSensors(sense)
       call OutputCircles(300,350,14,sense)
     elseif k="F"
       for i=0 to amount
         rForward 1
         if rBumper() then bump = true\rForward -2\break
       next
       call ReadSensors(sense)  
       if bump then sense=replace(sense,"1",1)
       call OutputCircles(300,350,14,sense)
      elseif k="B"
        amount = 30    
      elseif k="S"
        amount = 15
      elseif k="V"
        amount = 5
      elseif k="X"
        call SetXposition(p)
        call OutputCircles(300,350,14,p)
      elseif k="Y"
        call SetYposition(p)
        call OutputCircles(300,350,14,p)
      elseif k="H"
        call Heading(head)
        call OutputCircles(300,350,14,head)
      elseif k="T" 
        if Pen = "UP"
          Pen = "DN"
          rPen Down
        else
          Pen = "UP"
          rPen UP
        endif                    
      elseif k="Q"
        clearscr\end
     endif
   wend

return

sub SetXposition(&s)
  x = rGPSx()
  d = 800/6
  if x<=d
    s="100000"
  elseif x<=(2*d)
    s="010000"
  elseif x<=(3*d)
    s="001000"
  elseif x<=(4*d)
    s="000100"
  elseif x<=(5*d)
    s="000010"
  else
    s="000001"
  endif
return

sub SetYposition(&s)
  y = rGPSy()
  d = 440/6
  if y<=d+160
    s="100000"
  elseif y<160+2*d
    s="010000"
  elseif y<160+3*d
    s="001000"
  elseif y<160+4*d
    s="000100"
  elseif y<160+5*d
    s="000010"
  else
    s="000001"
  endif
return

sub ReadSensors(&s)
  s="000000"
  if rBumper() then s="100000"
  a = rFeel()
  if a&16 then s=replace(s,"1",2)
  if a&8 then  s=replace(s,"1",3)
  if a&4 then  s=replace(s,"1",4)
  if a&2 then  s=replace(s,"1",5)
  if a&1 then  s=replace(s,"1",6)
   
return

Initialize:
  ScrSetMetrics ,,,,0,0
  gosub Commands
  gosub DrawSensors
  gosub Instructions
  Seed = random(10000)
  SeedRandom(Seed)
  col = magenta
  if LB = "Hide Objects" then col = RGB(255,255,254)
  SetColor col,col
  gosub Environment
  gosub InitRobot
return  

SHOW:
  SeedRandom(Seed)
  Setcolor magenta,magenta
  gosub Environment
return   

Environment:
  circle 60,320,150+random(30),300+random(200)
  circle 300,425+random(50),550+random(100),550
  circle 500+random(200),200+random(50),660,300+random(80)
  AddButton "Start Over",260,205,140
  AddButton "Show Objects",260,170,140
  Setcolor RGB(255,255,254),white // make buttons into objects
  Rectangle 259,169,400,231  // by adding almost white line around them
  Setcolor black,white
  rectangle 266,320,507,375
  call OutputCircles(300,350,14,"000000")
return

MyMouse:  
  setcolor black,white
  while 1
  readmouse x,y,b
  xyString 10,550,x;y,"  "
  wend
wend
  

Instructions:                              
  xyString 200,270,"              INSTRUCTIONS "
  xyString 200,300,"The robot will appear in one of the corners."
  xyString 200,315,"Your goal is to move it to the opposite corner." 
  xyString 200,330,"Once you learn the program you should be able"
  xyString 200,345,"to perform the task without seeing the objects."
  xyString 200,370,"Click the desired button to start."
  
  AddButton "See Objects", 230,400,150
  AddButton "Hide Objects", 430,400,150
  repeat
    LB = LastButton()
  until LB<>""
  removebutton "See Objects"
  removebutton "Hide Objects"
  rectangle 200,250,700,500,white,white
return

sub OutputCircles(x,y,r,sense) 
  //if sense = 0 then sense="00000"
  for i = 0 to 5
    if substring(sense,i+1,1)="1"
      setcolor Blue,lightblue
    else
      setcolor blue,white
    endif
    
    call MyCircle(x,y,r)
    setcolor black
    xyString x-4,y-8,6-i
    x+=(2.5*r)
  next
return

DrawSensors:
  x= 220
  y= 140
  rLocate x,y
  setcolor red
  linewidth 10  
  for i= 0 to 180 step 45
    a=dtor(i)
    line x+25*cos(a),y-25*sin(a),x+40*cos(a),y-40*sin(a)
  next 
  linewidth 2               
  setcolor blue
  xyString x+50,y-10,"1"
  xyString x+35,y-46,"2"
  xyString x-3,y-62,"3"
  xyString x-43,y-46,"4"
  xyString x-56,y-10,"5"
  setcolor blue
  call OutputCircles(300,115,14,"000000")
return

Sub MyCircle(x,y,r)
  circle x-r,y-r,x+r,y+r
return  

InitRobot:
  r =random(100)
  if r<25 
    rLocate 20+random(100),180+random(100),random(360)
  elseif r<50
    rLocate 20+random(100),580-random(100),random(360)
  elseif r<75
    rLocate 780-random(100),180+random(100),random(360)
  else
    rLocate 780-random(100),580-random(100),random(360)
  endif  
  rInvisible RED
  Pen = "UP"
return

Commands:                            
  rectangle 0,0,799,599
  xyString 5,5,"L- rotate Left "
  xyString 5,20,"R-rotate Right"
  xyString 5,35,"F-move Forward"
  xyString 5,50,"B-Big (30)"
  xyString 5,65,"S-Small (15)"
  xyString 5,80,"V-Very small (5)"
  xyString 5,95,"H-Heading"
  xyString 5,110,"X-X position"
  xyString 5,125,"Y-Y position"
  xyString 5,140,"T-Toggle trail"
  line 150,0,150,160
  line 504,0,504,160
  //lineto 0,160
  line 0,160,800,160
  xyString 160,5,"You can rotate or move the robot 5,15"
  xyString 160,20,"or 30 units by entering L, R, or F." 
  xyString 160,35,"After each movement, the output pins"
  xyString 160,50,"will respond with this sensor data:"
  xyString 160,65,"(Out 6 is on if robot halts by itself)" 
  xyString 514,5,"X-Y positions and heading will"
  xyString 514,20,"show as below:"
  setcolor blue
  for i=0 to 6
    line 525+i*15,60,525+i*15,120
  next
  for i=0 to 6
    line 525,60+i*10,615,60+i*10
  next 
  setcolor gray
  line 525,48,610,48 
  line 514,60,514,120
  setcolor black
  xyString 510,41,"6"
  xyString 613,41,"1"
  xyString 510,124,"1"
  xyString 562,41,"X"
  xystring 510,80,"Y"
  xyString 515,140,"Output 6 ON for bottom headings"
  
  setcolor gray
  x=710\y=75\r=40
  circle x-50,y-50,x+50,y+50
  setcolor black
  xyString 755,65-13,"1" 
  xyString 656,65-13,"5"   
  xyString 755,65+15,"1" 
  xyString 656,65+15,"5" 
  xyString 706,20,"3" 
  xyString 706,114,"3"
  xyString 735,28,"2"
  xyString 735,106,"2"  
  xyString 676,28,"4"
  xyString 678,106,"4"         
 setcolor blue 
  for i=18 to 360-18 step 36
    a=dtor(i)
    line x,y,x+r*cos(a),y-r*sin(a)
  next
return

Sub Heading(&h)
  c=360-rCompass()
  c+=90
  if c>360 then c-=360
  if c<=36
    h="000001"
  elseif c<=2*36
    h="000010"
  elseif c<=3*36
    h="000100"
  elseif c<=4*36
    h="001000"
  elseif c<=5*36
    h="010000"
  elseif c<=6*36
    h="110000"
  elseif c<=7*36
    h="101000"
  elseif c<=8*36
    h="100100"
  elseif c<=9*36
    h="100010"
  else
    h="100001"
  endif
return
  
  
    
  

